=== scripts/Makefile ===
subdir-	+= basic kconfig
