=== tailor/flipper/kernel/drivers/misc/flipper/Makefile ===
obj-y	+= flipper.o
