=== debian/changelog ===
undertaker (1.6.1-4.1build3) bionic; urgency=medium

  * No-change rebuild to pick up the shared flex library.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Feb 2018 07:10:59 +0000

undertaker (1.6.1-4.1build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:25:07 +0000

undertaker (1.6.1-4.1build1) artful; urgency=medium

  * Rebuild against rebuild with default fPIC.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Sep 2017 09:06:52 +0200

undertaker (1.6.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc 7. (Closes: #853693)

 -- Adrian Bunk <bunk@debian.org>  Sun, 03 Sep 2017 14:54:27 +0300

undertaker (1.6.1-4) unstable; urgency=medium

  * Bug fix: "FTBFS in parallel builds", thanks to Lucas Nussbaum
    (Closes: #844980).
  * Bug fix: "add libfl-dev to Build-Depends", thanks to Helmut Grohne
    (Closes: #846452).

 -- Reinhard Tartler <siretart@debian.org>  Wed, 21 Dec 2016 21:03:52 +0000

undertaker (1.6.1-3) unstable; urgency=medium

  * Rebuild against aspectc++/libpuma 2.0
  * Rebuild against flex 2.6.1 (Closes: #833780), run flex at build-time.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 05 Mar 2016 18:52:29 -0500

undertaker (1.6.1-2) unstable; urgency=medium

  * Regenerate with Flex 2.6.0 (Closes: #813264)
  * Fix FTBFS with newer Puma/AspectC++
  * Bump standards version (no changes needed)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 27 Feb 2016 07:52:52 -0500

undertaker (1.6.1-1) unstable; urgency=medium

  * New upstream release
    - Incorporated patch for undertaker-checkpatch (Closes: #769137)
  * Add patch to fix FTBFS 'buildString' is not a member of 'Puma::StrCol'
    (Closes: #797896)
  * Relax CFLAGS (Don't add -Werror to everything)

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Jan 2016 06:15:12 -0500
