=== debian/control ===
Source: undertaker
Section: devel
Priority: optional
Maintainer: Christoph Egger <christoph@debian.org>
Uploaders: Reinhard Tartler <siretart@tauware.de>
Build-Depends:
 bison,
 check,
 debhelper (>= 9~),
 flex (>= 2.6.1),
 libboost-dev (>= 1.40),
 libboost-filesystem-dev (>= 1.40),
 libboost-regex-dev (>= 1.40),
 libboost-thread-dev (>= 1.40),
 libboost-wave-dev (>= 1.40),
 libfl-dev,
 libpstreams-dev,
 libpuma-dev (>= 1:2.1),
 picosat (>= 960),
 python-all (>= 2.6.6-3~)
Standards-Version: 3.9.7
Homepage: http://vamos.informatik.uni-erlangen.de/trac/undertaker
Vcs-Git: git://git.debian.org/git/collab-maint/undertaker.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/undertaker.git

Package: undertaker
Architecture: any
Depends: git, ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: variability-aware tool for static code analysis
 The "undertaker" is a tool suite for static source code analysis for
 checking C preprocessor directives. Also included are "golem", "vampyr"
 and "undertaker-tailor".
 .
 It can check their structure against different configuration models to
 find "dead" blocks that can never be selected and "undead" blocks that
 can never be deselected.
 .
 The included "golem" tool is able to infer variability constraints from
 Kbuild-like build systems, such as found in Linux, busybox and
 coreboot.  Its results greatly improves the model that undertaker uses
 for the analysis.
 .
 The tool "vampyr" is a conditional-compilation aware driver. It uses
 the "undertaker" tool to calculate a set of configurations and calls a
 backend-scanner on each of them. Supported scanners include: "gcc",
 "sparse", and "clang".
 .
 The tool "undertaker-tailor" calculates a kernel configuration based on
 a profile, which is traced with Linux ftrace mechanism. The resulting
 kernel exhibits a much smaller attack surface and results in a
 significant more secure kernel.
