=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_VERSION=$(shell cat VERSION)

%:
	dh $@ --with python2

override_dh_auto_build:
	cd undertaker && make REGENERATE_PARSERS=1 regenerate_parsers -j1
	dh_auto_build -- -j1

override_dh_auto_install:
	dh_auto_install -- DESTDIR="$(CURDIR)/debian/tmp" PREFIX=/usr ETCDIR=/etc SETUP_PY_INSTALL_EXTRA_ARG="--root $(CURDIR)/debian/tmp --install-layout=deb"

override_dh_auto_test:
	#$(MAKE) check

override_dh_auto_clean:
	$(MAKE) clean
	rm -rf build
