=== debian/watch ===
version=3

http://vamos.informatik.uni-erlangen.de/files/undertaker-(\d+[(.\d+)]+).tar.gz
